Crypto++ 8.6 Free C++ class library of cryptographic schemes

Public Member Functions | Static Public Member Functions | Static Public Attributes | List of all members
Weak::PanamaHash< B > Class Template Reference

Panama hash. More...

Inheritance diagram for Weak::PanamaHash< B >:

## Public Member Functions
unsigned int | DigestSize () const
| Provides the digest size of the hash. More...
void | TruncatedFinal (byte *hash, size_t size)
| Computes the hash of the current message. More...
std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm. More...
Public Member Functions inherited from AlgorithmImpl< IteratedHash< word32, NativeByteOrder, 32 >, PanamaHash< LittleEndian > >
std::string | AlgorithmName () const
| The algorithm name. More...
Public Member Functions inherited from IteratedHash< T_HashWordType, T_Endianness, T_BlockSize, T_Base >
unsigned int | BlockSize () const
| Provides the block size of the hash. More...
ByteOrder | GetByteOrder () const
| Provides the byte order of the hash. More...
void | CorrectEndianess (HashWordType *out, const HashWordType *in, size_t byteCount)
| Adjusts the byte ordering of the hash. More...
Public Member Functions inherited from IteratedHashBase< T_HashWordType, HashTransformation >
| IteratedHashBase ()
| Construct an IteratedHashBase.
unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this cipher. More...
unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance. More...
void | Update (const byte *input, size_t length)
| Updates a hash with additional input. More...
byte * | CreateUpdateSpace (size_t &size)
| Requests space which can be written into by the caller. More...
void | Restart ()
| Restart the hash. More...
void | TruncatedFinal (byte *digest, size_t digestSize)
| Computes the hash of the current message. More...
Public Member Functions inherited from HashTransformation
HashTransformation & | Ref ()
| Provides a reference to this object. More...
virtual void | Final (byte *digest)
| Computes the hash of the current message. More...
unsigned int | TagSize () const
| Provides the tag size of the hash. More...
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | Verify (const byte *digest)
| Verifies the hash of the current message. More...
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| Verifies the hash of the current message. More...
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...

## Static Public Member Functions
static const char * | StaticAlgorithmName ()
Static Public Member Functions inherited from AlgorithmImpl< IteratedHash< word32, NativeByteOrder, 32 >, PanamaHash< LittleEndian > >
static std::string | StaticAlgorithmName ()
| The algorithm name. More...

## Static Public Attributes
static const int | DIGESTSIZE = 32
Static Public Attributes inherited from IteratedHash< T_HashWordType, T_Endianness, T_BlockSize, T_Base >
static const int | BLOCKSIZE = T_BlockSize

## Additional Inherited Members
Public Types inherited from IteratedHash< T_HashWordType, T_Endianness, T_BlockSize, T_Base >
typedef T_Endianness | ByteOrderClass
typedef T_HashWordType | HashWordType
Public Types inherited from IteratedHashBase< T_HashWordType, HashTransformation >
typedef T_HashWordType | HashWordType

## Detailed Description

### template<class B = LittleEndian>
class Weak::PanamaHash< B >

Panama hash.

See also
  Panama Hash

Definition at line 44 of file panama.h.

## Member Function Documentation

## ◆ DigestSize()

template<class B = LittleEndian>

unsigned int Weak::PanamaHash< B >::DigestSize | ( |  | ) | const
| inline virtual

Provides the digest size of the hash.

Returns
  the digest size of the hash.

Implements HashTransformation.

Definition at line 50 of file panama.h.

## ◆ TruncatedFinal()

template<class B = LittleEndian>

void PanamaHash::TruncatedFinal | ( | byte * | digest,
|  | size_t | digestSize
| ) |  |
| virtual

Computes the hash of the current message.

Parameters

  digest | a pointer to the buffer to receive the hash
  digestSize | the size of the truncated digest, in bytes

TruncatedFinal() calls Final() and then copies digestSize bytes to digest. The hash is restarted the hash for the next message.

Precondition
  `COUNTOF(digest) <= DigestSize()` or `COUNTOF(digest) <= HASH::DIGESTSIZE` ensures the output byte buffer is a valid size.

Implements HashTransformation.

Definition at line 440 of file panama.cpp.

## ◆ AlgorithmProvider()

template<class B = LittleEndian>

std::string Weak::PanamaHash< B >::AlgorithmProvider | ( |  | ) | const
| inline virtual

Retrieve the provider of this algorithm.

Returns
  the algorithm provider

The algorithm provider can be a name like "C++", "SSE", "NEON", "AESNI", "ARMv8" and "Power8". C++ is standard C++ code. Other labels, like SSE, usually indicate a specialized implementation using instructions from a higher instruction set architecture (ISA). Future labels may include external hardware like a hardware security module (HSM).

Note
  Provider is not universally implemented yet.

Reimplemented from IteratedHashBase< T_HashWordType, HashTransformation >.

Definition at line 53 of file panama.h.

The documentation for this class was generated from the following files:

- panama.h
- panama.cpp